%ifarch x86_64
%define wine wine64-stable
%define mark64 ()(64bit)
%else
%define wine wine-stable
%define mark64 %{nil}
%endif

%define oname wine
#The program is still not the release version
%define major 1
%define libname %mklibname %{oname} %{major}
%define devname %mklibname %{oname} -d

%define winetricks_ver 20180217

# On 32-bit we have
# wine32 - those 32-bit binaries that are also used on 64-bit for 32-bit support
# wine - all other files (requires 'wine32')
# On 64-bit we have
# wine64 - all 64-bit files (suggests 'wine32')
# - Anssi 07/2010

Summary:	WINE Is Not An Emulator - runs MS Windows programs
Name:		wine-stable
Version:	3.0
Release:	2
Epoch:		2
License:	LGPLv2+
Group:		Emulators
Url:		http://www.winehq.com/
Source0:	http://dl.winehq.org/wine/source/%(echo %{version} |cut -d. -f1-2)/%{oname}-%{version}.tar.xz
Source1:	http://dl.winehq.org/wine/source/%(echo %{version} |cut -d. -f1-2)/%{oname}-%{version}.tar.xz.sign
# RH stuff
Source2:	wine.init
Source10:	%{name}.rpmlintrc
Source11:	https://github.com/Winetricks/winetricks/blob/%{winetricks_ver}/src/winetricks
Source12:	http://kegel.com/wine/wisotool

# (Anssi 05/2008) Adds:
# a: => /media/floppy (/mnt/floppy on 2007.1 and older)
# d: => $HOME (at config_dir creation time, not refreshed if $HOME changes;
#	note that Wine also provides $HOME in My Documents)
# only on 2008.0: e: => /media/cdrom (does not exist on 2008.1+)
# com4 => /dev/ttyUSB0 (replaces /dev/ttyS3)
# have to substitute @MDKVERSION@ in dlls/ntdll/server.c
Patch0:		wine-mdkconf.patch

BuildRequires:	bison
BuildRequires:	chrpath
BuildRequires:	desktop-file-utils
BuildRequires:	docbook-dtd-sgml
BuildRequires:	docbook-utils
BuildRequires:	flex
BuildRequires:	fontforge
BuildRequires:	imagemagick
BuildRequires:	prelink
BuildRequires:	sgml-tools
BuildRequires:	valgrind
BuildRequires:	cups-devel
BuildRequires:	gettext-devel
BuildRequires:	glibc-static-devel
BuildRequires:	gpm-devel
BuildRequires:	gsm-devel
BuildRequires:	isdn4k-utils-devel
BuildRequires:	openldap-devel
BuildRequires:	perl-devel
BuildRequires:	ungif-devel
BuildRequires:	unixODBC-devel
BuildRequires:	pkgconfig(alsa)
BuildRequires:	pkgconfig(dbus-1)
BuildRequires:	pkgconfig(egl)
BuildRequires:	pkgconfig(fontconfig)
BuildRequires:	pkgconfig(freetype2)
BuildRequires:	pkgconfig(gl)
BuildRequires:	pkgconfig(glu)
BuildRequires:	pkgconfig(gnutls)
BuildRequires:	pkgconfig(gstreamer-0.10)
BuildRequires:	pkgconfig(gstreamer-plugins-base-0.10)
BuildRequires:	pkgconfig(jack)
BuildRequires:	pkgconfig(lcms)
BuildRequires:	pkgconfig(libgphoto2)
BuildRequires:	pkgconfig(libmpg123)
BuildRequires:	pkgconfig(libpulse)
BuildRequires:	pkgconfig(librsvg-2.0)
BuildRequires:	pkgconfig(libtiff-4)
BuildRequires:	pkgconfig(libv4l2)
BuildRequires:	pkgconfig(libxslt)
BuildRequires:	pkgconfig(ncursesw)
BuildRequires:	pkgconfig(openal)
BuildRequires:	pkgconfig(osmesa)
BuildRequires:	pkgconfig(sane-backends)
BuildRequires:	pkgconfig(sm)
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(xcb-present)
BuildRequires:	pkgconfig(xcb-xfixes)
BuildRequires:	pkgconfig(xcomposite)
BuildRequires:	pkgconfig(xcursor)
BuildRequires:	pkgconfig(xext)
BuildRequires:	pkgconfig(xfixes)
BuildRequires:	pkgconfig(xinerama)
BuildRequires:	pkgconfig(xpm)
BuildRequires:	pkgconfig(xrandr)
BuildRequires:	pkgconfig(xrender)

ExclusiveArch:	%{ix86}
ExclusiveArch:	x86_64

#----------------------------------------------------------------------------

%ifarch x86_64
%package -n %{wine}
Summary:	WINE Is Not An Emulator - runs MS Windows programs
Group:		Emulators
Suggests:	wine32-stable = %{EVRD}
Suggests:	libncursesw.so.6%{mark64}
Suggests:	libncurses.so.6%{mark64}
Requires:	lib64dri-drivers
# wine dlopen's these, so let's add the dependencies ourself
Requires:	d3dadapter9.so.1%{mark64}
Requires:	libasound.so.2%{mark64}
Requires:	libfreetype.so.6%{mark64}
Requires:	libgphoto2.so.6%{mark64}
Requires:	libjpeg.so.8%{mark64}
Requires:	libmpg123.so.0%{mark64}
Requires:	libnss_mdns6.so.2%{mark64}
Requires:	libpng16.so.16%{mark64}
Requires:	libsane.so.1%{mark64}
Requires:	libv4l1.so.0%{mark64}
Requires:	libv4l2.so.0%{mark64}
Requires:	libXi.so.6%{mark64}
Requires:	libXrender.so.1%{mark64}
Requires:	libxslt.so.1%{mark64}
# This one is in Restricted repository so only suggest it
Suggests:	libtxc_dxtn.so%{mark64}
%else
# on 32-bit we always want wine32 package
Requires:	wine32-stable = %{EVRD}
%endif

%rename		%{wine}-utils
%rename		%{wine}-full
%rename		%{libname}-capi
%rename		%{libname}-twain
%rename		%{libname}
Provides:	wine-stable-bin = %{EVRD}
Requires:	xmessage
Suggests:	sane-frontends
Requires(post,postun):	desktop-common-data
Requires(post,preun):	rpm-helper

# for winetricks:
Requires:	cabextract
Requires:	unzip

Suggests:	webcore-fonts

%ifarch %{ix86}
Conflicts:	wine64-stable
%else
Conflicts:	wine-stable
%endif

Conflicts:	wine
Conflicts:	wine64

%description
Wine is a program which allows running Microsoft Windows programs
(including DOS, Windows 3.x and Win32 executables) on Unix. It
consists of a program loader which loads and executes a Microsoft
Windows binary, and a library (called Winelib) that implements Windows
API calls using their Unix or X11 equivalents.  The library may also
be used for porting Win32 code into native Unix executables.

%ifarch x86_64
%description -n %{wine}
Wine is a program which allows running Microsoft Windows programs
(including DOS, Windows 3.x and Win32 executables) on Unix. It
consists of a program loader which loads and executes a Microsoft
Windows binary, and a library (called Winelib) that implements Windows
API calls using their Unix or X11 equivalents.  The library may also
be used for porting Win32 code into native Unix executables.

This package contains the Win64 version of Wine. You need the wine32-stable
package from the 32-bit repository to be able to run 32-bit applications.
%endif

#----------------------------------------------------------------------------

%ifarch %{ix86}
%package -n wine32-stable
Summary:	32-bit support for Wine
Group:		Emulators
# This is not an EVR-specific requirement, as otherwise on x86_64 urpmi could
# resolve the dependency to wine64 even on upgrades, and therefore replace
# wine+wine32 installation with a wine32+wine64 installation. - Anssi
Requires:	wine-stable-bin
Suggests:	libncursesw.so.6
Suggests:	libncurses.so.6
Requires:	libdri-drivers
# wine dlopen's these, so let's add the dependencies ourself
Requires:	d3dadapter9.so.1
Requires:	libasound.so.2
Requires:	libfreetype.so.6
Requires:	libgphoto2.so.6
Requires:	libjpeg.so.8
Requires:	libmpg123.so.0
Requires:	libnss_mdns6.so.2
Requires:	libpng16.so.16
Requires:	libsane.so.1
Requires:	libudev.so.1
Requires:	libv4l1.so.0
Requires:	libv4l2.so.0
Requires:	libXcursor.so.1
Requires:	libXi.so.6
Requires:	libXrender.so.1
Requires:	libxslt.so.1
# This one is in Restricted repository so only suggest it
Suggests:	libtxc_dxtn.so
Conflicts:	wine32
# wine.1 manpage was moved to wine32 package
Conflicts:	wine-stable < 2:1.8
Conflicts:	wine64-stable < 2:1.8
Conflicts:	wine-stable-devel < 2:1.8
Conflicts:	wine64-stable-devel < 2:1.8

%description -n wine32-stable
Wine is a program which allows running Microsoft Windows programs
(including DOS, Windows 3.x and Win32 executables) on Unix.

This package contains the files needed to support 32-bit Windows
programs.
%endif

#----------------------------------------------------------------------------

%package -n %{wine}-devel
Summary:	Static libraries and headers for %{oname}
Group:		Development/C
Requires:	%{wine} = %{EVRD}
%rename		%{devname}
%ifarch %{ix86}
Conflicts:	wine64-stable-devel
%else
Conflicts:	wine-stable-devel
%endif
Conflicts:	wine-devel
Conflicts:	wine64-devel

%description -n %{wine}-devel
Wine is a program which allows running Microsoft Windows programs
(including DOS, Windows 3.x and Win32 executables) on Unix.

%{wine}-devel contains the libraries and header files needed to
develop programs which make use of wine.

Wine is often updated.

%files -n %{wine}-devel
%{_libdir}/%{oname}/*.a
%{_libdir}/libwine*.so
%{_libdir}/%{oname}/*.def
%{_includedir}/*
# %{_bindir}/fnt2bdf
%{_bindir}/wmc
%{_bindir}/wrc
%{_bindir}/winebuild
%{_bindir}/winegcc
%{_bindir}/wineg++
%{_bindir}/winecpp
%{_bindir}/widl
%{_bindir}/winedbg
%{_bindir}/winemaker
%{_bindir}/winedump
%{_mandir}/man1/wmc.1*
%{_mandir}/man1/wrc.1*
%{_mandir}/man1/winebuild.1*
%{_mandir}/man1/winemaker.1*
%{_mandir}/man1/winedump.1*
%{_mandir}/man1/widl.1*
%{_mandir}/man1/winedbg.1*
%{_mandir}/man1/wineg++.1*
%{_mandir}/man1/winegcc.1*

#----------------------------------------------------------------------------

%prep
%setup -qn %{oname}-%{version}
%patch0 -p1 -b .conf
sed -i 's,@MDKVERSION@,%{mdkversion},' dlls/ntdll/server.c

%build
%ifarch %{ix86}
# (Anssi 04/2008) bug #39604
# Some protection systems complain "debugger detected" with our
# -fomit-frame-pointer flag, so disable it.
export CFLAGS="%{optflags} -fno-omit-frame-pointer"
%endif

# (Anssi 04/2008)
# If icotool is present, it is used to rebuild icon files. It is in contrib
# so we do not do that; this is here to ensure that installed icoutils does
# not change build behaviour.
export ICOTOOL=false

autoreconf -fi
%configure2_5x \
	--with-pulse \
	--without-nas \
%ifarch x86_64
	--enable-win64
%endif

make depend
make

%install
%makeinstall_std LDCONFIG=/bin/true

install -m 0755 %{SOURCE11} %{buildroot}%{_bindir}/
install -m 0755 %{SOURCE12} %{buildroot}%{_bindir}/

# Danny: dirty:
# install -m755 tools/fnt2bdf -D %{buildroot}%{_bindir}/fnt2bdf

# Allow users to launch Windows programs by just clicking on the .exe file...
install -m755 %{SOURCE2} -D %{buildroot}%{_initrddir}/%{oname}

mkdir -p %{buildroot}%{_sysconfdir}/xdg/menus/applications-merged
cat > %{buildroot}%{_sysconfdir}/xdg/menus/applications-merged/mandriva-%{oname}.menu <<EOF
<!DOCTYPE Menu PUBLIC "-//freedesktop//DTD Menu 1.0//EN"
"http://www.freedesktop.org/standards/menu-spec/menu-1.0.dtd">
<Menu>
    <Name>Applications</Name>
    <Menu>
        <Name>Tools</Name>
        <Menu>
            <Name>Emulators</Name>
            <Menu>
                <Name>Wine</Name>
                <Directory>mandriva-%{oname}.directory</Directory>
                <Include>
                    <Category>X-MandrivaLinux-MoreApplications-Emulators-Wine</Category>
                </Include>
            </Menu>
        </Menu>
    </Menu>
</Menu>
EOF

mkdir -p %{buildroot}%{_datadir}/desktop-directories
cat > %{buildroot}%{_datadir}/desktop-directories/mandriva-%{oname}.directory <<EOF
[Desktop Entry]
Name=Wine
Icon=%{oname}
Type=Directory
EOF

mkdir -p %{buildroot}%{_datadir}/applications/
for i in	winecfg:Configurator \
		notepad:Notepad \
		winefile:File\ Manager \
		regedit:Registry\ Editor \
		winemine:Minesweeper \
		wineboot:Reboot \
		"wineconsole cmd":Command\ Line \
		"wine uninstaller:Wine Software Uninstaller";
do cat > %{buildroot}%{_datadir}/applications/mandriva-%{oname}-`echo $i|cut -d: -f1`.desktop << EOF
[Desktop Entry]
Name=`echo $i|cut -d: -f2`
Name[ru]=`echo $i|cut -d: -f3|sed 's/ Wine//'`
Comment=`echo $i|cut -d: -f2`
Comment[ru]=`echo $i|cut -d: -f3`
Exec=`echo $i|cut -d: -f1`
Icon=%{oname}
Terminal=false
Type=Application
Categories=X-MandrivaLinux-MoreApplications-Emulators-Wine;
EOF
done

# Categories=Emulator does nothing and is added as a workaround to kde #27700
desktop-file-install	--vendor="" \
			--add-mime-type=application/x-zip-compressed \
			--remove-mime-type=application/x-zip-compressed \
			--add-category=Emulator \
			--dir %{buildroot}%{_datadir}/applications %{buildroot}%{_datadir}/applications/wine.desktop

%ifarch x86_64
# fix the binary name
sed -i 's,Exec=wine ,Exec=wine64 ,' %{buildroot}%{_datadir}/applications/wine.desktop
%endif

install -d %{buildroot}{%{_liconsdir},%{_iconsdir},%{_miconsdir}}

# winecfg icon
convert dlls/user32/resources/oic_winlogo.ico[8] %{buildroot}%{_miconsdir}/%{oname}.png
convert dlls/user32/resources/oic_winlogo.ico[7] %{buildroot}%{_iconsdir}/%{oname}.png
convert dlls/user32/resources/oic_winlogo.ico[6] %{buildroot}%{_liconsdir}/%{oname}.png

# notepad icon
convert programs/notepad/notepad.ico[2] %{buildroot}%{_miconsdir}/notepad.png
convert programs/notepad/notepad.ico[7] %{buildroot}%{_iconsdir}/notepad.png
convert programs/notepad/notepad.ico[8] %{buildroot}%{_liconsdir}/notepad.png
# winefile icon
convert programs/winefile/winefile.ico[2] %{buildroot}%{_miconsdir}/winefile.png
convert programs/winefile/winefile.ico[8] %{buildroot}%{_iconsdir}/winefile.png
convert programs/winefile/winefile.ico[7] %{buildroot}%{_liconsdir}/winefile.png
# regedit icon
convert programs/regedit/regedit.ico[2] %{buildroot}%{_miconsdir}/regedit.png
convert programs/regedit/regedit.ico[8] %{buildroot}%{_iconsdir}/regedit.png
convert programs/regedit/regedit.ico[7] %{buildroot}%{_liconsdir}/regedit.png
# winemine icon
convert programs/winemine/winemine.ico[2] %{buildroot}%{_miconsdir}/winemine.png
convert programs/winemine/winemine.ico[8] %{buildroot}%{_iconsdir}/winemine.png
convert programs/winemine/winemine.ico[7] %{buildroot}%{_liconsdir}/winemine.png

# wine uninstaller icon:
convert programs/msiexec/msiexec.ico[2] %{buildroot}%{_miconsdir}/msiexec.png
convert programs/msiexec/msiexec.ico[8] %{buildroot}%{_iconsdir}/msiexec.png
convert programs/msiexec/msiexec.ico[7] %{buildroot}%{_liconsdir}/msiexec.png

# change the icons in the respective .desktop files, in order:
sed -i 's,Icon=%{oname},Icon=notepad,' %{buildroot}%{_datadir}/applications/mandriva-wine-notepad.desktop
sed -i 's,Icon=%{oname},Icon=winefile,' %{buildroot}%{_datadir}/applications/mandriva-wine-winefile.desktop
sed -i 's,Icon=%{oname},Icon=regedit,' %{buildroot}%{_datadir}/applications/mandriva-wine-regedit.desktop
sed -i 's,Icon=%{oname},Icon=winemine,' %{buildroot}%{_datadir}/applications/mandriva-wine-winemine.desktop
sed -i 's,Icon=%{oname},Icon=msiexec,' "%{buildroot}%{_datadir}/applications/mandriva-wine-wine uninstaller.desktop"

%ifarch x86_64
chrpath -d %{buildroot}%{_bindir}/{wine64,wineserver,wmc,wrc} %{buildroot}%{_libdir}/%{oname}/*.so
%else
chrpath -d %{buildroot}%{_bindir}/{wine,wineserver,wmc,wrc} %{buildroot}%{_libdir}/%{oname}/*.so
%endif

%ifarch x86_64
cat > README.install.urpmi <<EOF
This is the Win64 version of Wine. This version can only be used to run
64-bit Windows applications as is. For running 32-bit Windows applications,
you need to also install the 'wine32' package from the 32-bit repository.
EOF
%endif

%preun -n %{wine}
%_preun_service %{oname}

%post -n %{wine}
%_post_service %{oname}

%files -n %{wine}
%doc ANNOUNCE AUTHORS README
%ifarch x86_64
%doc README.install.urpmi
%{_bindir}/wine64
%{_bindir}/wine64-preloader
%endif
%{_initrddir}/%{oname}
%{_bindir}/winecfg
%{_bindir}/wineconsole*
%{_bindir}/wineserver
%{_bindir}/wineboot
%{_bindir}/function_grep.pl
#%{_bindir}/wineprefixcreate
%{_bindir}/msiexec
%{_bindir}/notepad
%{_bindir}/regedit
%{_bindir}/winemine
%{_bindir}/winepath
%{_bindir}/regsvr32
%{_bindir}/winefile
%{_bindir}/winetricks
%{_bindir}/wisotool
%lang(de) %{_mandir}/de.UTF-8/man1/winemaker.1*
%lang(de) %{_mandir}/de.UTF-8/man1/wineserver.1*
%lang(fr) %{_mandir}/fr.UTF-8/man1/winemaker.1*
%lang(fr) %{_mandir}/fr.UTF-8/man1/wineserver.1*
%{_mandir}/man1/wineserver.1*
%{_mandir}/man1/msiexec.1*
%{_mandir}/man1/notepad.1*
%{_mandir}/man1/regedit.1*
%{_mandir}/man1/regsvr32.1*
%{_mandir}/man1/wineboot.1*
%{_mandir}/man1/winecfg.1*
%{_mandir}/man1/wineconsole.1*
%{_mandir}/man1/winecpp.1*
%{_mandir}/man1/winefile.1*
%{_mandir}/man1/winemine.1*
%{_mandir}/man1/winepath.1*
%dir %{_datadir}/%{oname}
%{_datadir}/%{oname}/%{oname}.inf
%{_datadir}/%{oname}/l_intl.nls
%{_datadir}/applications/*.desktop
%{_sysconfdir}/xdg/menus/applications-merged/mandriva-%{oname}.menu
%{_datadir}/desktop-directories/mandriva-%{oname}.directory
%dir %{_datadir}/wine/fonts
%{_datadir}/wine/fonts/*
%{_miconsdir}/*.png
%{_iconsdir}/*.png
%{_liconsdir}/*.png

%ifarch %{ix86}
%files -n wine32-stable
%{_bindir}/wine
%{_bindir}/wine-preloader
%{_mandir}/man1/wine.1*
%lang(de) %{_mandir}/de.UTF-8/man1/wine.1*
%lang(fr) %{_mandir}/fr.UTF-8/man1/wine.1*
%lang(pl) %{_mandir}/pl.UTF-8/man1/wine.1*
%endif

%{_libdir}/libwine*.so.%{major}*
%dir %{_libdir}/%{oname}
%{_libdir}/%{oname}/*.cpl.so
%{_libdir}/%{oname}/*.drv.so
%{_libdir}/%{oname}/*.dll.so
%{_libdir}/%{oname}/*.exe.so
%{_libdir}/%{oname}/*.acm.so
%{_libdir}/%{oname}/*.ocx.so
%ifarch %{ix86}
%{_libdir}/%{oname}/*.vxd.so
%{_libdir}/%{oname}/*16.so
%endif
%{_libdir}/%{oname}/*.tlb.so
%{_libdir}/%{oname}/*.ds.so
%{_libdir}/%{oname}/*.sys.so
%{_libdir}/%{oname}/fakedlls

%changelog
